%global pkgver 2.0.3
#global prerel rc2
%global rpmrel 3

Name:		bluefish
Version:	%{pkgver}
Release:	%{?prerel:0.}%{rpmrel}%{?prerel:.%{prerel}}%{?dist}
Summary:	GTK2 web development application for experienced users
Group:		Development/Tools
License:	GPLv3+
URL:		http://bluefish.openoffice.nl/
Source0:	http://www.bennewitz.com/bluefish/stable/source/bluefish-%{version}%{?prerel:-%{prerel}}.tar.bz2
Patch0:		bluefish_bug_643150_643153.patch
Patch1:		fedora_bug_683497.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:	desktop-file-utils
BuildRequires:	enchant-devel >= 1.4.2
BuildRequires:	gettext
BuildRequires:	glib2-devel >= 2.16
BuildRequires:	gtk2-devel >= 2.12
%if 0%{?fedora} < 15
BuildRequires:	gucharmap-devel >= 2.20
%endif
BuildRequires:	intltool
BuildRequires:	libxml2-devel
# Needed to check man pages
BuildRequires:	/usr/bin/man
# For the Advanced Open function
Requires:	findutils, grep
Requires:	%{name}-shared-data = %{version}-%{release}

# Automatically upgrade bluefish-unstable
Obsoletes:	bluefish-unstable < %{version}-%{release}
Provides:	bluefish-unstable = %{version}-%{release}

# XML Catalog registration
Requires(post): /usr/bin/xmlcatalog, xml-common
Requires(postun): /usr/bin/xmlcatalog, xml-common

# Don't "provide" plugin shared objects
%{?filter_setup:
%filter_provides_in %{_libdir}/%{name}/.*\.so$
%filter_setup
}

%description
Bluefish is a powerful editor for experienced web designers and programmers.
Bluefish supports many programming and markup languages, but it focuses on
editing dynamic and interactive websites.

%package shared-data
Summary:	Architecture-independent data for %{name}
Group:		Development/Tools
BuildArch:	noarch
# For ownership of %%{_datadir}/mime/packages
Requires:	shared-mime-info
# For ownership of %%{_datadir}/icons/hicolor/*/{apps,mimetypes}
Requires:	hicolor-icon-theme

# Automatically upgrade bluefish-unstable-shared-data
Obsoletes:	bluefish-unstable-shared-data < %{version}-%{release}
Provides:	bluefish-unstable-shared-data = %{version}-%{release}

%description shared-data
Files common to every architecture version of %{name}.

%prep
%setup -q -n %{name}-%{version}%{?prerel:-%{prerel}}

# A bug in 2.0.3 prevents turning off the highlighting of block delimiters.
# https://bugzilla.gnome.org/show_bug.cgi?id=643150
# https://bugzilla.gnome.org/show_bug.cgi?id=643153
# https://bugzilla.redhat.com/show_bug.cgi?id=680626
%patch0 -p0

# Workaround for a crash-on-close bug
# https://bugzilla.gnome.org/show_bug.cgi?id=637990
# https://bugzilla.redhat.com/show_bug.cgi?id=683497
%patch1 -p0

%build
%configure	--disable-dependency-tracking \
		--disable-static \
		--disable-update-databases \
		--disable-xml-catalog-update \
		--docdir=%{_defaultdocdir}/%{name}-%{version}
%{__make} %{?_smp_mflags}

%install
%{__rm} -rf %{buildroot}
%{__mkdir_p} %{buildroot}%{_datadir}/applications
%{__make} install DESTDIR=%{buildroot} INSTALL="%{__install} -p"

%find_lang %{name}
%find_lang %{name}_plugin_about
%find_lang %{name}_plugin_charmap
%find_lang %{name}_plugin_entities
%find_lang %{name}_plugin_htmlbar
%find_lang %{name}_plugin_infbrowser
%find_lang %{name}_plugin_snippets
%{__cat} %{name}_plugin_{about,charmap,entities,htmlbar,infbrowser,snippets}.lang >> \
	%{name}.lang

/usr/bin/desktop-file-validate \
	%{buildroot}%{_datadir}/applications/%{name}.desktop

# Manually install docs so that they go into
# %%{_defaultdocdir}/%%{name}-%%{version} even after we put them in the
# shared-data subpackage
%{__install} -m 644 -p -t %{buildroot}%{_defaultdocdir}/%{name}-%{version}/ \
	AUTHORS ChangeLog COPYING NEWS README TODO

# Unpackaged files
%{__rm} -f %{buildroot}%{_libdir}/%{name}/*.la

%clean
%{__rm} -rf %{buildroot}

%post
/usr/bin/update-mime-database %{_datadir}/mime &> /dev/null || :
/usr/bin/update-desktop-database &> /dev/null || :
/usr/bin/xmlcatalog --noout --add 'delegateURI' \
	'http://bluefish.openoffice.nl/ns/bflang/2.0/' \
	'%{_datadir}/xml/%{name}' \
	%{_sysconfdir}/xml/catalog &> /dev/null || :

%postun
/usr/bin/update-mime-database %{_datadir}/mime &> /dev/null || :
/usr/bin/update-desktop-database &> /dev/null || :
if [ "$1" = 0 ]; then
	/usr/bin/xmlcatalog --noout --del \
		'http://bluefish.openoffice.nl/ns/bflang/2.0/' \
		%{_sysconfdir}/xml/catalog &> /dev/null || :
fi

%files
%defattr(-,root,root,-)
%{_bindir}/%{name}
%{_libdir}/%{name}/

%files shared-data -f %{name}.lang
%defattr(-,root,root,-)
%{_datadir}/%{name}/
%{_datadir}/applications/%{name}.desktop
%{_datadir}/mime/packages/%{name}.xml
%{_datadir}/icons/hicolor/*/mimetypes/application-x-bluefish-project.png
%{_datadir}/icons/hicolor/*/apps/%{name}.png
%{_datadir}/icons/hicolor/scalable/mimetypes/bluefish-project.svg
%{_datadir}/icons/hicolor/scalable/apps/bluefish-icon.svg
%{_datadir}/pixmaps/application-x-bluefish-project.png
%{_datadir}/pixmaps/%{name}.png
%{_datadir}/xml/%{name}/
%{_defaultdocdir}/%{name}-%{version}/
%{_mandir}/man1/%{name}.1*

%changelog
* Thu Mar 10 2011 Paul Howarth <paul@city-fan.org> - 2.0.3-3
- Add workaround for crash on close (Gnome bug 637990, #683497)

* Sun Feb 27 2011 Paul Howarth <paul@city-fan.org> - 2.0.3-2
- Fix highlighting of block delimiters (Gnome bugs 643150 and 643153, #680626)

* Wed Feb 23 2011 Paul Howarth <paul@city-fan.org> - 2.0.3-1
- Update to 2.0.3
- Drop gtk2 version requirement back down to 2.12

* Mon Feb  7 2011 Paul Howarth <paul@city-fan.org> - 2.0.3-0.2.rc2
- Update to 2.0.3-rc2

* Tue Jan  4 2011 Paul Howarth <paul@city-fan.org> - 2.0.3-0.1.rc1
- Update to 2.0.3-rc1
- Drop patches now integrated into upstream release
- Bump gtk2 version requirement to 2.14

* Sun Dec 19 2010 Paul Howarth <paul@city-fan.org> - 2.0.2-6
- Update patch for #663014 to fix another potential issue that was discovered

* Wed Dec 15 2010 Paul Howarth <paul@city-fan.org> - 2.0.2-5
- Fix crash in autosave (#663014)

* Thu Nov 18 2010 Paul Howarth <paul@city-fan.org> - 2.0.2-4
- Fix crash when removing files/projects from recently-used lists (#653299)

* Thu Oct  7 2010 Paul Howarth <paul@city-fan.org> - 2.0.2-3
- Drop charmap plugin from Rawhide for now

* Wed Sep 29 2010 jkeating - 2.0.2-1.1
- Rebuilt for gcc bug 634757

* Fri Sep 17 2010 Paul Howarth <paul@city-fan.org> - 2.0.2-1
- Update to 2.0.2 (minor bugfix and minor feature enhancement release)
  - Two crashes have been resolved
  - A "jump to reference" feature has been added
  - Translations improved

* Tue Sep  7 2010 Paul Howarth <paul@city-fan.org> - 2.0.2-0.1.rc1
- Update to 2.0.2-rc1
- Drop patch for #626246, no longer needed
- License changed from GPLv2+ to GPLv3+

* Thu Aug 26 2010 Paul Howarth <paul@city-fan.org> - 2.0.1-2
- Fix crash in File Open dialog with filter applied (#626246)
- Change buildreq "man" to "/usr/bin/man" since the "man" package has been
  obsoleted by "man-db" from Fedora 14

* Fri Jun 18 2010 Paul Howarth <paul@city-fan.org> - 2.0.1-1
- Update to 2.0.1
- Drop upstreamed log10 linking patch
- Drop redundant buildreqs pcre-devel and python-devel

* Wed Feb 17 2010 Paul Howarth <paul@city-fan.org> - 2.0.0-2
- Bluefish uses GIO rather than GnomeVFS so buildreq libgnomeui-devel is
  no longer needed
- Explicitly buildreq libxml2-devel

* Tue Feb 16 2010 Paul Howarth <paul@city-fan.org> - 2.0.0-1 
- 2.0.0 release 
- Remove upstreamed projects patch 
- Update log10 linking patch

* Mon Feb 15 2010 Paul Howarth <paul@city-fan.org> - 2.0.0-0.4.rc3
- Fix FTBFS due to missing -lm linking for log10 function (#565197)

* Sun Jan 31 2010 Paul Howarth <paul@city-fan.org> - 2.0.0-0.3.rc3
- Update to 2.0.0-rc3
- Drop snippets patch
- Add upstream patch resolving some project-related issues (#549552)

* Wed Jan 27 2010 Paul Howarth <paul@city-fan.org> - 2.0.0-0.2.rc2
- Update to 2.0.0-rc2
- Apply upstream patch to re-enable snippets menu
- Disable python plugin on upstream advice (#549552 comment 6)
- Disable dependency tracking to speed up build
- Register XML catalog in %%post and %%postun

* Wed Dec 30 2009 Paul Howarth <paul@city-fan.org> - 2.0.0-0.1.rc1
- Update to major new version - 2.0.0-rc1 (#549552)
- Drop all patches
- No longer need buildreqs gail-devel, gnome-mime-data, gnome-vfs2-devel
- Buildreq gucharmap-devel >= 2.20 for charmap plugin
- Buildreq intltool for translations
- Buildreq man to check man pages
- Buildreq python-devel for python plugin
- Req findutils and grep for the Advanced Open function
- Use %%{name} macro for spec file compatibility with bluefish-unstable
- Call %%find_lang multiple times for plugin translations
- Filter provides for plugin shared objects
- Desktop file now installed as part of upstream install process, so use
  desktop-file-validate instead of desktop-file-install
- Explicitly enable python plugin (disabled by default despite docs to contrary)
- All supported releases now have noarch subpackages, so drop conditionals

* Thu Nov 19 2009 Paul Howarth <paul@city-fan.org> - 1.0.7-9
- Buildreq gnome-mime-data, not pulled in by gnome-vfs2 since 2.24.1-8 (#539223)
- Buildreq enchant-devel >= 1.4.2, needed for enchant_dict_add
- Make %%files list more explicit

* Thu Jul 30 2009 Paul Howarth <paul@city-fan.org> - 1.0.7-8
- Include patch from Caolan McNamara for using enchant rather than aspell for
  spell-checking (#509514)
  http://fedoraproject.org/wiki/Releases/FeatureDictionary
- Try to maintain timestamps on unmodified files from upstream

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.7-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Feb 26 2009 Paul Howarth <paul@city-fan.org> - 1.0.7-6
- Split off shared-data noarch subpackage for Fedora 10 onwards
- Add buildreq gail-devel to fix broken detection of libgnomeui on F-9

* Mon Feb 23 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.7-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Thu Feb 14 2008 Paul Howarth <paul@city-fan.org> - 1.0.7-4
- rebuild with gcc 4.3.0 for Fedora 9

* Mon Jan 21 2008 Paul Howarth <paul@city-fan.org> - 1.0.7-3
- include patch from upstream VCS to work around problem editing syntax
  highlighting patterns (#390871)

* Sun Aug 26 2007 Paul Howarth <paul@city-fan.org> - 1.0.7-2
- clarify license as GPL version 2 or later
- unexpand tabs in spec
- update scriptlets and drop scriptlet dependencies

* Mon Nov  6 2006 Paul Howarth <paul@city-fan.org> - 1.0.7-1
- update to 1.0.7
- update download URL
- don't add category X-Fedora in desktop files

* Tue Aug 29 2006 Paul Howarth <paul@city-fan.org> - 1.0.5-4
- rebuild for dynamic linking speedups (FE6)

* Mon May 22 2006 Paul Howarth <paul@city-fan.org> - 1.0.5-3
- fix broken debuginfo packages by not stripping binaries (#192617)
- cosmetic changes to spec file
- add extra doc files AUTHORS ChangeLog NEWS README TODO
- use full command paths for reproducible builds

* Thu Feb 16 2006 Paul Howarth <paul@city-fan.org> - 1.0.5-2
- rebuild

* Mon Feb  6 2006 Paul Howarth <paul@city-fan.org> - 1.0.5-1
- update to 1.0.5
- include manpage

* Mon Sep  5 2005 Paul Howarth <paul@city-fan.org> - 1.0.4-1
- update to 1.0.4

* Sun Aug 21 2005 Paul Howarth <paul@city-fan.org> - 1.0.3-1
- update to 1.0.3

* Sat Aug 20 2005 Michael Schwendt <mschwendt[AT]users.sf.net> - 1.0.2-3
- rebuilt

* Fri Jul 29 2005 Paul Howarth <paul@city-fan.org> - 1.0.2-2
- buildrequire libgnomeui-devel, not libgnomeui

* Fri Jul 29 2005 Paul Howarth <paul@city-fan.org> - 1.0.2-1
- update to 1.0.2
- add dist tag
- add libgnomeui support as per upstream package (#161234, #163804)
- add project desktop entry
- desktop entry munging not needed

* Sun May 22 2005 Jeremy Katz <katzj@redhat.com> - 1.0-4
- rebuild on all arches

* Fri Apr  7 2005 Michael Schwendt <mschwendt[AT]users.sf.net>
- rebuilt

* Sun Feb 20 2005 Phillip Compton <pcompton[AT]proteinmedia.com> 1.0-2
- Fix for absolute path to icon in desktop entry.

* Tue Jan 11 2005 Phillip Compton <pcompton[AT]proteinmedia.com> 1.0-1
- 1.0.

* Sat Jan 01 2005 Phillip Compton <pcompton[AT]proteinmedia.com> 1.0-0.1.cvs20041231
- cvs20041231

* Fri Nov 12 2004 Phillip Compton <pcompton[AT]proteinmedia.com> 0.13-0.fdr.4
- Redirect output for post/postun.
- More mime-types in desktop entry.
- Fix changelog.

* Thu Nov 11 2004 Phillip Compton <pcompton[AT]proteinmedia.com> 0.13-0.fdr.3
- Updated .desktop entry for new mime-type system.
- Added post/postun update-desktop-database.
- Removed files from old mime-type system.

* Mon Apr 12 2004 Phillip Compton <pcompton[AT]proteinmedia.com> 0:0.13-0.fdr.2
- Now including .applications file and mime info.

* Sat Apr 10 2004 Phillip Compton <pcompton[AT]proteinmedia.com> 0:0.13-0.fdr.1
- Updated to 0.13.

* Mon Nov 24 2003 Phillip Compton <pcompton[AT]proteinmedia.com> 0:0.12-0.fdr.1
- Updated to 0.12.
- BuildReq gnome-vfs2-devel.

* Sun Oct 17 2003 Phillip Compton <pcompton[AT]proteinmedia.com> 0.11-0.fdr.5
- Release detection dropped..1

* Mon Oct 06 2003 Phillip Compton <pcompton[AT]proteinmedia.com> 0:0.11-0.fdr.4
- Improved release detection.

* Sun Sep 28 2003 Phillip Compton <pcompton[AT]proteinmedia.com> 0:0.11-0.fdr.3
- Modified for Fedora Core release detection.
- Updated description.

* Mon Sep 15 2003 Phillip Compton <pcompton[AT]proteinmedia.com> 0:0.11-0.fdr.2
- Now auto-detecting RH release.

* Sun Jul 27 2003 Phillip Compton <pcompton[AT]proteinmedia.com> 0:0.11-0.fdr.1
- Updated to 0.11.

* Fri Jul 25 2003 Phillip Compton <pcompton[AT]proteinmedia.com> 0:0.10-0.fdr.2
- Enable feature diferention for shrike vs severn.
- BuildReq aspell-devel for severn.
- in bluefish.desktop: Terminal=0 => Terminal=false.
- Source0 path updated.

* Thu Jul 17 2003 Phillip Compton <pcompton[AT]proteinmedia.com> 0:0.10-0.fdr.1
- Updated to 0.10.

* Thu Jul 17 2003 Phillip Compton <pcompton[AT]proteinmedia.com> 0:0.10-0.fdr.0.1.20030716
- 2003-07-16 snapshot.

* Thu Apr 10 2003 Phillip Compton <pcompton[AT]proteinmedia.com> 0:0.9-0.fdr.5
- Added gettext to BuildRequires.

* Tue Apr 01 2003 Phillip Compton <pcompton[AT]proteinmedia.com> 0:0.9-0.fdr.4
- Changed category to X-Fedora-Extra.
- Added Epoch:0.
- Removed redundant Requires entries.

* Sun Mar 23 2003 Phillip Compton <pcompton[AT]proteinmedia.com> 0.9-0.fdr.3
- Updated for inclusion in fedora

* Wed Mar 05 2003 Phillip Compton <pcompton[AT]proteinmedia.com> 0.9-0.fdr.2
- Cleaned up spec file

* Wed Feb 19 2003 Phillip Compton <pcompton[AT]proteinmedia.com> 0.9-1.fedora.1
- Updated to 0.9

* Sat Feb 8 2003 Phillip Compton
- Update to snapshot: 20030207

* Wed Feb 5 2003 Phillip Compton
- Update to snapshot: 20030205

* Wed Jan 15 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to the latest snapshot which should be more stable.

* Sat Jan 11 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.8.
- Major spec file updates based on the one from Matthias Haase.

* Thu May  2 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Rebuilt against Red Hat Linux 7.3.
- Added the %{?_smp_mflags} expansion.

* Mon Nov 19 2001 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 0.7.
- Spec file simplifications since the build is now cleaner :-)

* Wed May  2 2001 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Spec file cleanup for Red Hat 7.1.
- Added a GNOME desktop entry.
- Compiled with kgcc and reported the problems encountered with gcc 2.96.

* Fri May 5 2000 Bo Forslund <bo.forslund@abc.se>
- fine tuning of the spec file
- possible to build with all processors on smp machines
- an entry for RedHats wmconfig

* Tue Mar 21 2000 CW Zuckschwerdt <zany@triq.net>
- complete rewrite of spec file
- relocateable on build-time
- no privileges required while building
- fix for install_location (should really be $(LIBDIR)/bluefish!)
- included man, locale and lib into RPM (was seriously broken)

* Thu Jan 13 2000 Chris Lea <chrislea@luciddesigns.com>
- Fixed up spec file some. bluefish-0.3.5

* Wed Nov 17 1999 Chris Lea <chrislea@luciddesigns.com>
- added spec file. this is my third RPM that I've made a spec
  file for, so please be merciful if I've screwed something up
